/* 
 * actualizer_mod.c
 *
 * actualizes the buffers of the active WAVEs
 *
 * Copyright (C) 1998 Hermann Samso
 */

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <ncurses.h>
#include "types.h"
#include "delfin.h"
#include "display.h"
#include "audiodrv.h"
#include "wave.h"
#include "module.h"


void ActInit(void) {
	if (trace_on)
		fprintf(stderr, "ActInit()\n");

	ModuleDisplay();
}


void ActExit(void) {
	if (trace_on)
		fprintf(stderr, "ActExit()\n");

}


void ActCtrl(INT input) {
/*
	INT keys[] = {
	};
*/

	if (trace_on)
		fprintf(stderr, "ActCtrl()\n");
		
}


void ActExec(void) {
	INT i;
	INT nr_waves = WaveHowMany();
	WAVE* wave;


	if (trace_on)
		fprintf(stderr, "ActExec()\n");


	// actualize active WAVEs' buffer
	for (i = 0; i < nr_waves; i++) {
		wave = WaveGetByIndex(i);
		if (wave->active) {
//fprintf(stderr, "name:%s buffer:%p\n", wave->name, wave->buffer);
			wave->position = WaveBlockToSample(wave->buffer, wave, wave->position, AudioGetBufferSize(), TRUE);
		}
	}
}


void ActDisplay(void) {
	if (trace_on)
		fprintf(stderr, "ActDisplay()\n");

	DisplayClearBottom();
	mvprintw(LINES-2, 0, "[%s]", actualizer_mod.name);
}



MODULE actualizer_mod = {
	NULL,			/* next MODULE  in list */
	NULL,			/* previous MODULE in list */
	"actualizer",
	"v1998.2.1 by Hermann Samso",
	ActInit,
	ActExit,
	ActCtrl,
	ActExec,
	ActDisplay
};
